#line 1 "C:/Users/stefan.filipovic/Downloads/Mikromedia 5 FPI for STM32F7 CAPACITIVE/mikromedia-sdk/driver/bsp_microsd_driver.c"
#line 1 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/mikromedia-sdk/hal/hal.h"
#line 1 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/mikromedia-sdk/hal/hal_stm32.h"
#line 1 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/mikromedia-sdk/compiler/compiler.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/mikromedia-sdk/compiler/mikroc_arm.h"
#line 41 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/mikromedia-sdk/compiler/mikroc_arm.h"
typedef void ( * hal_spi_write_fp_t ) ( unsigned int );
typedef unsigned int ( * hal_spi_read_fp_t ) ( unsigned int );

typedef struct
{
 hal_spi_write_fp_t spi_write;
 hal_spi_read_fp_t spi_read;

} hal_spi_obj_t;

typedef unsigned int ( * hal_i2c_start_fp_t ) ( void );
typedef unsigned int ( * hal_i2c_write_fp_t ) ( unsigned char, unsigned char *, unsigned long, unsigned long );
typedef void ( * hal_i2c_read_fp_t ) ( unsigned char, unsigned char *, unsigned long, unsigned long );

typedef struct
{
 hal_i2c_start_fp_t i2c_start;
 hal_i2c_write_fp_t i2c_write;
 hal_i2c_read_fp_t i2c_read;

} hal_i2c_obj_t;

typedef void ( * hal_uart_write_fp_t ) ( unsigned int );
typedef unsigned int ( * hal_uart_read_fp_t ) ( void );
typedef unsigned int ( * hal_uart_ready_fp_t ) ( void );

typedef struct
{
 hal_uart_write_fp_t uart_write;
 hal_uart_read_fp_t uart_read;
 hal_uart_ready_fp_t uart_ready;

} hal_uart_obj_t;

typedef void ( * hal_pwm_duty_fp_t ) ( unsigned int, char, char );

typedef void ( * hal_pwm_stop_fp_t ) ( char );

typedef struct
{
 hal_pwm_duty_fp_t pwm_duty;

 hal_pwm_stop_fp_t pwm_stop;

} hal_pwm_obj_t;

typedef unsigned int ( * hal_adc_read_fp_t ) ( unsigned int );
typedef unsigned int ( * hal_adc_sample_fp_t ) ( unsigned int );

typedef struct
{
 hal_adc_read_fp_t adc_read;
 hal_adc_sample_fp_t adc_sample;

} hal_adc_obj_t;
#line 19 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/mikromedia-sdk/hal/hal_stm32.h"
static hal_spi_write_fp_t fp_spi_write;
static hal_spi_read_fp_t fp_spi_read;

static void hal_spi_map ( const hal_spi_obj_t * spi_obj )
{
 fp_spi_write = spi_obj->spi_write;
 fp_spi_read = spi_obj->spi_read;
}

static void hal_spi_write ( uint8_t * buf, uint16_t len )
{
 uint8_t *ptr = buf;

 while ( len-- )
 {
 fp_spi_write( *( ptr++ ) );
 }
}

static void hal_spi_read ( uint8_t * buf, uint16_t len )
{
 uint8_t *ptr = buf;

 while ( len-- )
 {
 *( ptr++ ) = fp_spi_read( 0x00 );
 }
}

static void hal_spi_transfer ( uint8_t * buf_in, uint8_t * buf_out, uint16_t len )
{
 uint8_t *in = buf_in;
 uint8_t *out = buf_out;

 while ( len-- )
 {
 *( out++ ) = fp_spi_read( *( in++ ) );
 }
}

static hal_i2c_start_fp_t fp_i2c_start;
static hal_i2c_write_fp_t fp_i2c_write;
static hal_i2c_read_fp_t fp_i2c_read;

static void hal_i2c_map ( const hal_i2c_obj_t * i2c_obj )
{
 fp_i2c_start = i2c_obj->i2c_start;
 fp_i2c_write = i2c_obj->i2c_write;
 fp_i2c_read = i2c_obj->i2c_read;
}

static int hal_i2c_start ( void )
{
 int res = 0;

 res |= fp_i2c_start( );

 return res;
}

static int hal_i2c_write ( uint8_t slaveAddress, uint8_t * pBuf, uint16_t nBytes, uint8_t endMode )
{
 int res = 0;
 uint8_t *ptr = pBuf;

 res |= fp_i2c_write( slaveAddress, ptr, nBytes, endMode );

 return res;
}

static int hal_i2c_read( uint8_t slaveAddress, uint8_t * pBuf, uint16_t nBytes, uint8_t endMode )
{
 int res = 0;
 uint8_t *ptr = pBuf;

 fp_i2c_read( slaveAddress, ptr, nBytes, endMode );

 return res;
}

static hal_uart_write_fp_t fp_uart_write;
static hal_uart_read_fp_t fp_uart_read;
static hal_uart_ready_fp_t fp_uart_ready;

static void hal_uart_map ( const hal_uart_obj_t * uart_obj )
{
 fp_uart_write = uart_obj->uart_write;
 fp_uart_read = uart_obj->uart_read;
 fp_uart_ready = uart_obj->uart_ready;
}

static void hal_uart_write ( uint8_t input )
{
 fp_uart_write( input );
}

static uint8_t hal_uart_read ( void )
{
 return ( uint8_t ) fp_uart_read( );
}

static uint8_t hal_uart_ready ( void )
{
 return ( uint8_t ) fp_uart_ready( );
}

static hal_pwm_duty_fp_t fp_pwm_set_duty;

static hal_pwm_stop_fp_t fp_pwm_stop;

static void hal_pwm_map ( const hal_pwm_obj_t * pwm_obj )
{
 fp_pwm_set_duty = pwm_obj->pwm_duty;

 fp_pwm_stop = pwm_obj->pwm_stop;
}

static void hal_pwm_start ( uint32_t channel, uint32_t duty, uint32_t invert )
{
 fp_pwm_set_duty( ( unsigned int ) duty, ( char ) invert, ( char ) channel );

}

static void hal_pwm_stop ( uint32_t channel )
{
 fp_pwm_stop( ( char ) channel );
}

static hal_adc_read_fp_t fp_adc_read;
static hal_adc_sample_fp_t fp_adc_get_sample;

static void hal_adc_map ( const hal_adc_obj_t * adc_obj )
{
 fp_adc_read = adc_obj->adc_read;
 fp_adc_get_sample = adc_obj->adc_sample;
}

static uint32_t hal_adc_read ( uint32_t channel )
{
 return ( uint32_t ) fp_adc_read( ( unsigned int ) channel );
}
#line 1 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/mikromedia-sdk/driver/bsp_microsd_driver.h"
#line 1 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/portable/bsp.h"
#line 1 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/mikromedia-sdk/bsp/mmb.h"
#line 1 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/mikromedia-sdk/bsp/mmb_5_fpi.h"
#line 1 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/portable/mmb_5_fpi_stm32.h"
#line 1 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/mikromedia-sdk/compiler/compiler.h"
#line 79 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/portable/mmb_5_fpi_stm32.h"
extern sfr sbit TFT_BLED;
extern sfr sbit TFT_CS;
extern sfr sbit TFT_RD;
extern sfr sbit TFT_RS;
extern sfr sbit TFT_RST;
extern sfr sbit TFT_WR;

static void Write_to_Data_Lines ( unsigned char _hi, unsigned char _lo )
{
 GPIOE_ODR = ( unsigned int ) ( _lo | ( _hi << 8 ) );
}

static void Set_Index ( unsigned short index )
{
 TFT_RS = 0;
 Write_to_Data_Lines( 0, index );
 TFT_WR = 0;
 asm nop;
 TFT_WR = 1;
}

static void Write_Command ( unsigned short cmd )
{
 TFT_RS = 1;
 Write_to_Data_Lines( 0, cmd );
 TFT_WR = 0;
 asm nop;
 TFT_WR = 1;
}

static void Write_Data ( unsigned int _data )
{
 TFT_RS = 1;
 Write_to_Data_Lines( ( _data >> 8 ), ( _data & 0x00FF ) );
 TFT_WR = 0;
 asm nop;
 TFT_WR = 1;
}

static void hal_display_init ( void )
{


 TFT_Set_Default_Mode( );
 TFT_Set_Active( Set_Index, Write_Command, Write_Data );
 TFT_Init_SSD1963_Board_70( 800, 480 );
 TFT_Set_DBC_SSD1963( 255 );
}





static uint8_t hal_touch_init ( void )
{


 GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_6 );
 GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_7 );

 GPIOB_ODR.B6 = 1;

 while ( GPIOB_IDR.B7 == 0 )
 {
 GPIOB_ODR.B6 = 0;
 Delay_us( 10 );
 GPIOB_ODR.B6 = 1;
 Delay_us( 10 );
 }

 I2C1_Init_Advanced( 400000, &_GPIO_MODULE_I2C1_PB67 );

 FT5XX6_SetI2CAddress( 0x38 );

 if ( FT5XX6_IsOperational( ) != FT5XX6_OK )
 {
 return FT5XX6_FAILURE;
 }

 FT5XX6_SetDefaultMode( );
 FT5XX6_SetController( _TC_FT5X16 );
 FT5XX6_SetSizeAndRotation( 800, 480, 2 );

 return FT5XX6_OK;
}
#line 175 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/portable/mmb_5_fpi_stm32.h"
static void hal_console_init ( void )
{


 UART6_Init_Advanced(
 115200,
 _UART_8_BIT_DATA,
 _UART_NOPARITY,
 _UART_ONE_STOPBIT,
 &_GPIO_MODULE_UART6_PC67
 );
}









static sbit BSP_DC_STATUS at GPIOF_IDR.B6;



static sbit BSP_CHARGER_STATUS at GPIOF_IDR.B3;
#line 213 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/portable/mmb_5_fpi_stm32.h"
const static hal_adc_obj_t BSP_POWER_ADC_MODULE =
{
 ADC3_Read,
 ADC3_Get_Sample
};

static void hal_power_init ( void )
{


 GPIO_Digital_Input( &GPIOF_BASE, _GPIO_PINMASK_6 );



 GPIO_Digital_Input( &GPIOF_BASE, _GPIO_PINMASK_3 );



 GPIO_Analog_Input( &GPIOF_BASE, _GPIO_PINMASK_5 );



 ADC_Set_Input_Channel(  ( 15 )  );
 ADC3_Init( );
}
#line 249 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/portable/mmb_5_fpi_stm32.h"
const static hal_spi_obj_t BSP_MICROSD_SPI_MODULE =
{
 SPI1_Write,
 SPI1_Read
};

static void hal_microsd_init ( void )
{


 GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_2);



 SPI1_Init_Advanced( _SPI_FPCLK_DIV16,
 _SPI_MASTER |
 _SPI_8_BIT |
 _SPI_CLK_IDLE_LOW |
 _SPI_FIRST_CLK_EDGE_TRANSITION |
 _SPI_MSB_FIRST |
 _SPI_SS_DISABLE |
 _SPI_SSM_ENABLE |
 _SPI_SSI_1,
 &_GPIO_MODULE_SPI1_PA56_PB5 );
}









static sbit BSP_FLASH_CE at GPIOB_ODR.B11;

const static hal_spi_obj_t BSP_FLASH_SPI_MODULE =
{
 SPI2_Write,
 SPI2_Read
};

static void hal_flash_init ( void )
{


 GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_11 );



 SPI2_Init_Advanced(
 _SPI_FPCLK_DIV16,
 _SPI_MASTER |
 _SPI_8_BIT |
 _SPI_CLK_IDLE_LOW |
 _SPI_FIRST_CLK_EDGE_TRANSITION |
 _SPI_MSB_FIRST |
 _SPI_SS_DISABLE |
 _SPI_SSM_ENABLE |
 _SPI_SSI_1,
 &_GPIO_MODULE_SPI2_PB13_14_15
 );

 BSP_FLASH_CE = 1;
}
#line 392 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/portable/mmb_5_fpi_stm32.h"
static sbit BSP_RF_CS at GPIOG_ODR.B9;
static sbit BSP_RF_CE at GPIOG_ODR.B12;
static sbit BSP_RF_INT at GPIOG_IDR.B10;

const static hal_spi_obj_t BSP_RF_SPI_MODULE =
{
 SPI2_Write,
 SPI2_Read
};

static void hal_rf_init ( void )
{


 GPIO_Digital_Input( &GPIOG_BASE, _GPIO_PINMASK_10 );



 GPIO_Digital_Output( &GPIOG_BASE, _GPIO_PINMASK_12 );



 GPIO_Digital_Output( &GPIOG_BASE, _GPIO_PINMASK_9);



 SPI2_Init_Advanced(
 _SPI_FPCLK_DIV16,
 _SPI_MASTER |
 _SPI_8_BIT |
 _SPI_CLK_IDLE_LOW |
 _SPI_FIRST_CLK_EDGE_TRANSITION |
 _SPI_MSB_FIRST |
 _SPI_SS_DISABLE |
 _SPI_SSM_ENABLE |
 _SPI_SSI_1,
 &_GPIO_MODULE_SPI2_PB13_14_15
 );

}










static volatile sbit BSP_MP3_DREQ at GPIOD_IDR.B9;
static volatile sbit BSP_MP3_CS at GPIOD_ODR.B11;
static volatile sbit BSP_MP3_RST at GPIOD_ODR.B8;
static volatile sbit BSP_MP3_DCS at GPIOD_ODR.B10;

static const hal_spi_obj_t BSP_MP3_SPI_MODULE =
{
 SPI2_Write,
 SPI2_Read
};

static void hal_mp3_init ( void )
{


 GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_9 );



 GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_11 );



 GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_8 );



 GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_10 );



 SPI2_Init_Advanced(
 _SPI_FPCLK_DIV256,
 _SPI_MASTER |
 _SPI_8_BIT |
 _SPI_CLK_IDLE_LOW |
 _SPI_FIRST_CLK_EDGE_TRANSITION |
 _SPI_MSB_FIRST |
 _SPI_SS_DISABLE |
 _SPI_SSM_ENABLE |
 _SPI_SSI_1,
 &_GPIO_MODULE_SPI2_PB13_14_15
 );
}









static sbit BSP_ACCEL_INT_1 at GPIOB_IDR.B9;
static sbit BSP_ACCEL_INT_2 at GPIOF_IDR.B2;

const static hal_i2c_obj_t BSP_ACCEL_I2C_MODULE =
{
 I2C1_Start,
 I2C1_Write,
 I2C1_Read
};

static void hal_accel_init ( void )
{


 GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_9 );



 GPIO_Digital_Input( &GPIOF_BASE, _GPIO_PINMASK_2 );


 GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_6 );

 GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_7 );

 GPIOB_ODR.B6 = 0;
 GPIOB_ODR.B7 = 0;

 Delay_ms(100);

 I2C1_Init_Advanced( 400000, &_GPIO_MODULE_I2C1_PB67 );
 Delay_ms(500);
}
#line 596 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/portable/mmb_5_fpi_stm32.h"
static volatile sbit CC3100_HIB_PIN at GPIOB_ODR.B10;
static volatile sbit CC3100_CS_PIN at GPIOC_ODR.B8;
static volatile sbit CC3100_RST_PIN at GPIOG_ODR.B1;

const static hal_spi_obj_t BSP_WIFI_SPI_MODULE =
{
 SPI1_Write,
 SPI1_Read
};

static void hal_wifi_init ( void )
{


 NVIC_IntDisable( IVT_INT_EXTI0 );



 GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_10 );



 GPIO_Digital_Output( &GPIOG_BASE, _GPIO_PINMASK_1 );



 GPIO_Digital_Output( &GPIOC_BASE, _GPIO_PINMASK_8 );



 GPIO_Digital_Input( &GPIOG_BASE, _GPIO_PINMASK_0 );
#line 636 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/portable/mmb_5_fpi_stm32.h"
 SPI1_Init_Advanced(
 _SPI_FPCLK_DIV16,
 _SPI_MASTER |
 _SPI_8_BIT |
 _SPI_CLK_IDLE_LOW |
 _SPI_FIRST_CLK_EDGE_TRANSITION |
 _SPI_MSB_FIRST |
 _SPI_SS_DISABLE |
 _SPI_SSM_ENABLE |
 _SPI_SSI_1,
 &_GPIO_MODULE_SPI1_PA56_PB5
 );

 CC3100_CS_PIN = 1;
}








static void hal_buzzer_init ( void )
{


 GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_8 );



 Sound_Init( &GPIOB_ODR, 8 );
}
#line 695 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/portable/mmb_5_fpi_stm32.h"
static void hal_rtc_init ( void )
{


 RCC_APB1ENR.PWREN = 1;
 RCC_APB1LPENR.PWREN = 1;
 if (RCC_BDCR.RTCEN == 0){
 PWR_CR1.DBP = 1;

 RCC_BDCR |= 0x00010000;


 RTC_WPR = 0xCA;
 RTC_WPR = 0x53;
 RCC_CSR = 0x00000000ul;
 RCC_BDCR = 0x8101u;
 RTC_CR |= 0x00880000ul;
 LSERDYIE_bit = 1;
 }
 while(RTC_ISR.B5 != 1){}

 while(RCC_BDCR.LSERDY != 1){};


 RTC_WPR = 0xFF;
}
#line 761 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/portable/mmb_5_fpi_stm32.h"
static void hal_shuttle_init ( void ) {


}
#line 42 "c:/users/stefan.filipovic/downloads/mikromedia 5 fpi for stm32f7 capacitive/mikromedia-sdk/driver/bsp_microsd_driver.h"
void bsp_microsd_init ( void );
#line 24 "C:/Users/stefan.filipovic/Downloads/Mikromedia 5 FPI for STM32F7 CAPACITIVE/mikromedia-sdk/driver/bsp_microsd_driver.c"
static const uint8_t ERR_CODES[16][14] =
{
 "INIT error",
 "QFORMAT error",
 "MKDIR error",
 "CHDIR error",
 "RMDIR error",
 "DIR error",
 "RENDIR error",
 "ASSIGN error",
 "READ error",
 "APPEND error",
 "REWRITE error",
 "DELETE error",
 "RENAME error",
 "SWAP error",
 "SETDATE error",
 "GETDATE error"
};
#line 55 "C:/Users/stefan.filipovic/Downloads/Mikromedia 5 FPI for STM32F7 CAPACITIVE/mikromedia-sdk/driver/bsp_microsd_driver.c"
void bsp_microsd_init( void )
{
 hal_microsd_init( );
}
