/*
    accel_test.c

-----------------------------------------------------------------------------

  This file is part of mikroSDK.
  
  Copyright (c) 2017,  MikroElektronika - http://www.mikroe.com

  All rights reserved.

----------------------------------------------------------------------------- */

/**
        \file   shuttle_test.c

- Version               :   1.0.0
- Date                  :   May 2019
- Developer             :   Marko Jovanovic

---

    Generated from module test template.
    
*/
/* -------------------------------------------------------------------------- */

#include "test_types.h"
#include "test_console.h"

// Include BSP drivers which will be tested.
//  ...

#if ( _MMB_MODULE_SHUTTLE == 1 )

//  Default task delay in ms

#define TASK_DELAY                      2000
#define TASK_NAME                       "SHUTTLE Test"

//  Declare necessary initialization variables.
//  ...

static int16_t  x;
static int16_t  y;
static int16_t  z;

void shuttle_test ( test_param_t * tp )
{
    switch ( tp->step ) 
    {
        case TEST_PREINIT :
        {
            tp->step = TEST_INIT;
            tp->delay = TASK_DELAY;
            strcpy( tp->name, TASK_NAME );

            break;
        }
        case TEST_INIT :
        {
            //  Initialize BSP module.
            //  ...

            GPIO_Digital_Output(&GPIOA_BASE, _GPIO_PINMASK_0 | _GPIO_PINMASK_1 | _GPIO_PINMASK_3 | _GPIO_PINMASK_8);
            GPIO_Digital_Output(&GPIOC_BASE, _GPIO_PINMASK_0 | _GPIO_PINMASK_1 | _GPIO_PINMASK_2 | _GPIO_PINMASK_3
                                             | _GPIO_PINMASK_6 | _GPIO_PINMASK_7 | _GPIO_PINMASK_9 | _GPIO_PINMASK_10 | _GPIO_PINMASK_11 | _GPIO_PINMASK_12);

            GPIO_Digital_Output(&GPIOD_BASE, _GPIO_PINMASK_5 | _GPIO_PINMASK_7 | _GPIO_PINMASK_14 | _GPIO_PINMASK_15);

            GPIO_Digital_Output(&GPIOF_BASE, _GPIO_PINMASK_0 | _GPIO_PINMASK_1 | _GPIO_PINMASK_7 | _GPIO_PINMASK_8 | _GPIO_PINMASK_9 | _GPIO_PINMASK_10);
            GPIO_Digital_Output(&GPIOG_BASE, _GPIO_PINMASK_11 | _GPIO_PINMASK_13 | _GPIO_PINMASK_14 | _GPIO_PINMASK_15);
            //--------- MB1 ---------
            GPIOF_ODR.B8 = 0;    //AN
            GPIOG_ODR.B14 = 0;   //RST
            GPIOG_ODR.B15 = 0;    //CS
            GPIOC_ODR.B10 = 0;    //SCK
            GPIOC_ODR.B11 = 0;    //MISO
            GPIOC_ODR.B12 = 0;    //MOSI
            GPIOD_ODR.B15 = 0;   //PWM
            GPIOD_ODR.B7 = 0;    //INT
            GPIOA_ODR.B3 = 0;    //UART_RX
            GPIOD_ODR.B5 = 0;    //UART_TX
            GPIOF_ODR.B1 = 0;    //SCL
            GPIOF_ODR.B0 = 0;    //SDA
         //--------- MB2 ---------
            GPIOF_ODR.B9 = 0;    //AN
            GPIOC_ODR.B1 = 0;   //RST
            GPIOC_ODR.B0 = 0;    //CS
            GPIOC_ODR.B10 = 0;    //SCK
            GPIOC_ODR.B11 = 0;    //MISO
            GPIOC_ODR.B12 = 0;    //MOSI
            GPIOD_ODR.B14 = 0;   //PWM
            GPIOG_ODR.B11 = 0;    //INT
            GPIOA_ODR.B1 = 0;    //UART_RX
            GPIOA_ODR.B0 = 0;    //UART_TX
            GPIOF_ODR.B1 = 0;    //SCL
            GPIOF_ODR.B0 = 0;    //SDA
            //--------- MB3 ---------
            GPIOF_ODR.B10 = 0;    //AN
            GPIOC_ODR.B2 = 0;   //RST
            GPIOC_ODR.B3 = 0;    //CS
            GPIOC_ODR.B10 = 0;    //SCK
            GPIOC_ODR.B11 = 0;    //MISO
            GPIOC_ODR.B12 = 0;    //MOSI
            GPIOF_ODR.B7 = 0;   //PWM
            GPIOG_ODR.B13 = 0;    //INT
            GPIOC_ODR.B7 = 0;    //UART_RX
            GPIOC_ODR.B6 = 0;    //UART_TX
            GPIOA_ODR.B8 = 0;    //SCL
            GPIOC_ODR.B9 = 0;    //SDA
            //  Perform all necessary post initialization and configuration actions.
            //  ...

            //  ...
            //  End of module initialization.

            tp->step = TEST_TASK;

            break;
        }
        case TEST_TASK :
        {
            /*
                Test Loop.
            */
            GPIOF_ODR.B8 = 1;    //AN
            GPIOG_ODR.B14 = 1;   //RST
            GPIOG_ODR.B15 = 1;    //CS
            GPIOC_ODR.B10 = 1;    //SCK
            GPIOC_ODR.B11 = 1;    //MISO
            GPIOC_ODR.B12 = 1;    //MOSI
            GPIOD_ODR.B15 = 1;   //PWM
            GPIOD_ODR.B7 = 1;    //INT
            GPIOA_ODR.B3 = 1;    //UART_RX
            GPIOD_ODR.B5 = 1;    //UART_TX
            GPIOF_ODR.B1 = 1;    //SCL
            GPIOF_ODR.B0 = 1;    //SDA
         //--------- MB2 ---------
            GPIOF_ODR.B9 = 1;    //AN
            GPIOC_ODR.B1 = 1;   //RST
            GPIOC_ODR.B0 = 1;    //CS
            GPIOC_ODR.B10 = 1;    //SCK
            GPIOC_ODR.B11 = 1;    //MISO
            GPIOC_ODR.B12 = 1;    //MOSI
            GPIOD_ODR.B14 = 1;   //PWM
            GPIOG_ODR.B11 = 1;    //INT
            GPIOA_ODR.B1 = 1;    //UART_RX
            GPIOA_ODR.B0 = 1;    //UART_TX
            GPIOF_ODR.B1 = 1;    //SCL
            GPIOF_ODR.B0 = 1;    //SDA
            //--------- MB3 ---------
            GPIOF_ODR.B10 = 1;    //AN
            GPIOC_ODR.B2 = 1;   //RST
            GPIOC_ODR.B3 = 1;    //CS
            GPIOC_ODR.B10 = 1;    //SCK
            GPIOC_ODR.B11 = 1;    //MISO
            GPIOC_ODR.B12 = 1;    //MOSI
            GPIOF_ODR.B7 = 1;   //PWM
            GPIOG_ODR.B13 = 1;    //INT
            GPIOC_ODR.B7 = 1;    //UART_RX
            GPIOC_ODR.B6 = 1;    //UART_TX
            GPIOA_ODR.B8 = 1;    //SCL
            GPIOC_ODR.B9 = 1;    //SDA

            Delay_ms(3000);

        //--------- MB1 ---------
            GPIOF_ODR.B8 = 0;    //AN
            GPIOG_ODR.B14 = 0;   //RST
            GPIOG_ODR.B15 = 0;    //CS
            GPIOC_ODR.B10 = 0;    //SCK
            GPIOC_ODR.B11 = 0;    //MISO
            GPIOC_ODR.B12 = 0;    //MOSI
            GPIOD_ODR.B15 = 0;   //PWM
            GPIOD_ODR.B7 = 0;    //INT
            GPIOA_ODR.B3 = 0;    //UART_RX
            GPIOD_ODR.B5 = 0;    //UART_TX
            GPIOF_ODR.B1 = 0;    //SCL
            GPIOF_ODR.B0 = 0;    //SDA
         //--------- MB2 ---------
            GPIOF_ODR.B9 = 0;    //AN
            GPIOC_ODR.B1 = 0;   //RST
            GPIOC_ODR.B0 = 0;    //CS
            GPIOC_ODR.B10 = 0;    //SCK
            GPIOC_ODR.B11 = 0;    //MISO
            GPIOC_ODR.B12 = 0;    //MOSI
            GPIOD_ODR.B14 = 0;   //PWM
            GPIOG_ODR.B11 = 0;    //INT
            GPIOA_ODR.B1 = 0;    //UART_RX
            GPIOA_ODR.B0 = 0;    //UART_TX
            GPIOF_ODR.B1 = 0;    //SCL
            GPIOF_ODR.B0 = 0;    //SDA
            //--------- MB3 ---------
            GPIOF_ODR.B10 = 0;    //AN
            GPIOC_ODR.B2 = 0;   //RST
            GPIOC_ODR.B3 = 0;    //CS
            GPIOC_ODR.B10 = 0;    //SCK
            GPIOC_ODR.B11 = 0;    //MISO
            GPIOC_ODR.B12 = 0;    //MOSI
            GPIOF_ODR.B7 = 0;   //PWM
            GPIOG_ODR.B13 = 0;    //INT
            GPIOC_ODR.B7 = 0;    //UART_RX
            GPIOC_ODR.B6 = 0;    //UART_TX
            GPIOA_ODR.B8 = 0;    //SCL
            GPIOC_ODR.B9 = 0;    //SDA

        //--------- MB1 ---------
            GPIOF_ODR.B8 = 1;    //AN
            Delay_ms(300);
            GPIOF_ODR.B8 = 0;

            GPIOG_ODR.B14 = 1;   //RST
            Delay_ms(300);
            GPIOG_ODR.B14 = 0;

            GPIOG_ODR.B15 = 1;    //CS
            Delay_ms(300);
            GPIOG_ODR.B15 = 0;

            GPIOC_ODR.B10 = 1;    //SCK
            Delay_ms(300);
            GPIOC_ODR.B10 = 0;

            GPIOC_ODR.B11 = 1;    //MISO
            Delay_ms(300);
            GPIOC_ODR.B11 = 0;

            GPIOC_ODR.B12 = 1;    //MOSI
            Delay_ms(300);
            GPIOC_ODR.B12 = 0;

            GPIOD_ODR.B15 = 1;   //PWM
            Delay_ms(300);
            GPIOD_ODR.B15 = 0;

            GPIOD_ODR.B7 = 1;    //INT
            Delay_ms(300);
            GPIOD_ODR.B7 = 0;

            GPIOA_ODR.B3 = 1;    //UART_RX
            Delay_ms(300);
            GPIOA_ODR.B3 = 0;

            GPIOD_ODR.B5 = 1;    //UART_TX
            Delay_ms(300);
            GPIOD_ODR.B5 = 0;

            GPIOF_ODR.B1 = 1;    //SCL
            Delay_ms(300);
            GPIOF_ODR.B1 = 0;

            GPIOF_ODR.B0 = 1;    //SDA
            Delay_ms(300);
            GPIOF_ODR.B0 = 0;

         //--------- MB2 ---------
            GPIOF_ODR.B9 = 1;    //AN
            Delay_ms(300);
            GPIOF_ODR.B9 = 0;

            GPIOC_ODR.B1 = 1;   //RST
            Delay_ms(300);
            GPIOC_ODR.B1 = 0;

            GPIOC_ODR.B0 = 1;    //CS
            Delay_ms(300);
            GPIOC_ODR.B0 = 0;

            GPIOC_ODR.B10 = 1;    //SCK
            Delay_ms(300);
            GPIOC_ODR.B10 = 0;

            GPIOC_ODR.B11 = 1;    //MISO
            Delay_ms(300);
            GPIOC_ODR.B11 = 0;

            GPIOC_ODR.B12 = 1;    //MOSI
            Delay_ms(300);
            GPIOC_ODR.B12 = 0;

            GPIOD_ODR.B14 = 1;   //PWM
            Delay_ms(300);
            GPIOD_ODR.B14 = 0;

            GPIOG_ODR.B11 = 1;    //INT
            Delay_ms(300);
            GPIOG_ODR.B11 = 0;

            GPIOA_ODR.B1 = 1;    //UART_RX
            Delay_ms(300);
            GPIOA_ODR.B1 = 0;

            GPIOA_ODR.B0 = 1;    //UART_TX
            Delay_ms(300);
            GPIOA_ODR.B0 = 0;

            GPIOF_ODR.B1 = 1;    //SCL
            Delay_ms(300);
            GPIOF_ODR.B1 = 0;

            GPIOF_ODR.B0 = 1;    //SDA
            Delay_ms(300);
            GPIOF_ODR.B0 = 0;

            //--------- MB3 ---------
            GPIOF_ODR.B10 = 1;    //AN
            Delay_ms(300);
            GPIOF_ODR.B10 = 0;

            GPIOC_ODR.B2 = 1;   //RST
            Delay_ms(300);
            GPIOC_ODR.B2 = 0;

            GPIOC_ODR.B3 = 1;    //CS
            Delay_ms(300);
            GPIOC_ODR.B3 = 0;

            GPIOC_ODR.B10 = 1;    //SCK
            Delay_ms(300);
            GPIOC_ODR.B10 = 0;

            GPIOC_ODR.B11 = 1;    //MISO
            Delay_ms(300);
            GPIOC_ODR.B11 = 0;

            GPIOC_ODR.B12 = 1;    //MOSI
            Delay_ms(300);
            GPIOC_ODR.B12 = 0;

            GPIOF_ODR.B7 = 1;   //PWM
            Delay_ms(300);
            GPIOF_ODR.B7 = 0;

            GPIOG_ODR.B13 = 1;    //INT
            Delay_ms(300);
            GPIOG_ODR.B13 = 0;

            GPIOC_ODR.B7 = 1;    //UART_RX
            Delay_ms(300);
            GPIOC_ODR.B7 = 0;

            GPIOC_ODR.B6 = 1;    //UART_TX
            Delay_ms(300);
            GPIOC_ODR.B6 = 0;

            GPIOA_ODR.B8 = 1;    //SCL
            Delay_ms(300);
            GPIOA_ODR.B8 = 0;

            GPIOC_ODR.B9 = 1;    //SDA
            Delay_ms(300);
            GPIOC_ODR.B9 = 0;

            break;
        }
    }
}

#endif

/* -------------------------------------------------------------------------- */
/*
    accel_test.c

  Copyright (c) 2017,  MikroElektronika - http://www.mikroe.com

  All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

3. All advertising materials mentioning features or use of this software
   must display the following acknowledgment:
   This product includes software developed by the  MikroElektronika.

4. Neither the name of the  MikroElektronika nor the
   names of its contributors may be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY MIKROELEKTRONIKA ''AS IS'' AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL MIKROELEKTRONIKA BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

----------------------------------------------------------------------------- */